Whamcloud - gitweb
Branch b1_8
[fs/lustre-release.git] / lustre / tests / conf-sanity.sh
1 #!/bin/bash
2 # requirement:
3 #       add uml1 uml2 uml3 in your /etc/hosts
4
5 # FIXME - there is no reason to use all of these different
6 #   return codes, espcially when most of them are mapped to something
7 #   else anyway.  The combination of test number and return code
8 #   figure out what failed.
9
10 set -e
11
12 ONLY=${ONLY:-"$*"}
13
14 # bug number for skipped test:      13369
15 ALWAYS_EXCEPT=" $CONF_SANITY_EXCEPT 34a"
16 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
17
18 SRCDIR=`dirname $0`
19 PATH=$PWD/$SRCDIR:$SRCDIR:$SRCDIR/../utils:$PATH
20
21 SAVE_PWD=$PWD
22 LUSTRE=${LUSTRE:-`dirname $0`/..}
23 RLUSTRE=${RLUSTRE:-$LUSTRE}
24 HOSTNAME=`hostname`
25
26 . $LUSTRE/tests/test-framework.sh
27 init_test_env $@
28 # STORED_MDSSIZE is used in test_18
29 if [ -n "$MDSSIZE" ]; then
30     STORED_MDSSIZE=$MDSSIZE
31 fi
32 # use small MDS + OST size to speed formatting time
33 MDSSIZE=40000
34 OSTSIZE=40000
35 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
36
37 remote_mds_nodsh && skip "remote MDS with nodsh" && exit 0
38 remote_ost_nodsh && skip "remote OST with nodsh" && exit 0
39
40 #
41 [ "$SLOW" = "no" ] && EXCEPT_SLOW="0 1 2 3 6 7 15 18 24b 25 30 31 32 33 34a 45"
42
43 assert_DIR
44
45 reformat() {
46         formatall
47 }
48
49 writeconf() {
50         local facet=mds
51         shift
52         stop ${facet} -f
53         rm -f ${facet}active
54         # who knows if/where $TUNEFS is installed?  Better reformat if it fails...
55         do_facet ${facet} "$TUNEFS --writeconf $MDSDEV" || echo "tunefs failed, reformatting instead" && reformat
56
57         gen_config
58 }
59
60 gen_config() {
61         # The MGS must be started before the OSTs for a new fs, so start
62         # and stop to generate the startup logs.
63         start_mds
64         start_ost
65         wait_osc_import_state mds ost FULL
66         stop_ost
67         stop_mds
68 }
69
70 reformat_and_config() {
71         reformat
72         gen_config
73 }
74
75 start_mds() {
76         echo "start mds service on `facet_active_host mds`"
77         start mds $MDSDEV $MDS_MOUNT_OPTS || return 94
78 }
79
80 stop_mds() {
81         echo "stop mds service on `facet_active_host mds`"
82         # These tests all use non-failover stop
83         stop mds -f  || return 97
84 }
85
86 start_ost() {
87         echo "start ost1 service on `facet_active_host ost1`"
88         start ost1 `ostdevname 1` $OST_MOUNT_OPTS || return 95
89 }
90
91 stop_ost() {
92         echo "stop ost1 service on `facet_active_host ost1`"
93         # These tests all use non-failover stop
94         stop ost1 -f  || return 98
95 }
96
97 start_ost2() {
98         echo "start ost2 service on `facet_active_host ost2`"
99         start ost2 `ostdevname 2` $OST_MOUNT_OPTS || return 92
100 }
101
102 stop_ost2() {
103         echo "stop ost2 service on `facet_active_host ost2`"
104         # These tests all use non-failover stop
105         stop ost2 -f  || return 93
106 }
107
108 start_client() {
109         echo "start client on `facet_active_host client`"
110         start client || return 99
111 }
112
113 stop_client() {
114         echo "stop client on `facet_active_host client`"
115         stop client || return 100
116 }
117
118 mount_client() {
119         local MOUNTPATH=$1
120         echo "mount $FSNAME on ${MOUNTPATH}....."
121         zconf_mount `hostname` $MOUNTPATH  || return 96
122 }
123
124 remount_client() {
125         local SAVEMOUNTOPT=$MOUNTOPT
126         MOUNTOPT="remount,$1"
127         local MOUNTPATH=$2
128         echo "remount '$1' lustre on ${MOUNTPATH}....."
129         zconf_mount `hostname`  $MOUNTPATH  || return 96
130         MOUNTOPT=$SAVEMOUNTOPT
131 }
132
133 umount_client() {
134         local MOUNTPATH=$1
135         echo "umount lustre on ${MOUNTPATH}....."
136         zconf_umount `hostname` $MOUNTPATH || return 97
137 }
138
139 manual_umount_client(){
140         local rc
141         local FORCE=$1
142         echo "manual umount lustre on ${MOUNT}...."
143         do_facet client "umount -d ${FORCE} $MOUNT"
144         rc=$?
145         return $rc
146 }
147
148 setup() {
149         start_ost
150         start_mds
151         mount_client $MOUNT
152         df $MOUNT
153 }
154
155 setup_noconfig() {
156         start_mds
157         start_ost
158         mount_client $MOUNT
159 }
160
161 cleanup_nocli() {
162         stop_mds || return 201
163         stop_ost || return 202
164         unload_modules || return 203
165 }
166
167 cleanup() {
168         umount_client $MOUNT || return 200
169         cleanup_nocli || return $?
170 }
171
172 check_mount() {
173         do_facet client "cp /etc/passwd $DIR/a" || return 71
174         do_facet client "rm $DIR/a" || return 72
175         # make sure lustre is actually mounted (touch will block,
176         # but grep won't, so do it after)
177         do_facet client "grep $MOUNT' ' /proc/mounts > /dev/null" || return 73
178         echo "setup single mount lustre success"
179 }
180
181 check_mount2() {
182         do_facet client "touch $DIR/a" || return 71
183         do_facet client "rm $DIR/a" || return 72
184         do_facet client "touch $DIR2/a" || return 73
185         do_facet client "rm $DIR2/a" || return 74
186         echo "setup double mount lustre success"
187 }
188
189 build_test_filter
190
191 if [ "$ONLY" == "setup" ]; then
192         setup
193         exit
194 fi
195
196 if [ "$ONLY" == "cleanup" ]; then
197         cleanup
198         exit
199 fi
200
201 #create single point mountpoint
202
203 reformat_and_config
204
205 test_0() {
206         setup
207         check_mount || return 41
208         cleanup || return $?
209 }
210 run_test 0 "single mount setup"
211
212 test_1() {
213         start_ost
214         echo "start ost second time..."
215         setup
216         check_mount || return 42
217         cleanup || return $?
218 }
219 run_test 1 "start up ost twice (should return errors)"
220
221 test_2() {
222         start_ost
223         start_mds
224         echo "start mds second time.."
225         start_mds
226         mount_client $MOUNT
227         check_mount || return 43
228         cleanup || return $?
229 }
230 run_test 2 "start up mds twice (should return err)"
231
232 test_3() {
233         setup
234         #mount.lustre returns an error if already in mtab
235         mount_client $MOUNT && return $?
236         check_mount || return 44
237         cleanup || return $?
238 }
239 run_test 3 "mount client twice (should return err)"
240
241 test_4() {
242         setup
243         touch $DIR/$tfile || return 85
244         stop_ost -f
245         cleanup
246         eno=$?
247         # ok for ost to fail shutdown
248         if [ 202 -ne $eno ]; then
249                 return $eno;
250         fi
251         return 0
252 }
253 run_test 4 "force cleanup ost, then cleanup"
254
255 test_5a() {     # was test_5
256         setup
257         touch $DIR/$tfile || return 1
258         fuser -m -v $MOUNT && echo "$MOUNT is in use by user space process."
259
260         stop_mds -f || return 2
261
262         # cleanup may return an error from the failed
263         # disconnects; for now I'll consider this successful
264         # if all the modules have unloaded.
265         umount -d $MOUNT &
266         UMOUNT_PID=$!
267         sleep 6
268         echo "killing umount"
269         kill -TERM $UMOUNT_PID
270         echo "waiting for umount to finish"
271         wait $UMOUNT_PID
272         if grep " $MOUNT " /proc/mounts; then
273                 echo "test 5: /proc/mounts after failed umount"
274                 umount $MOUNT &
275                 UMOUNT_PID=$!
276                 sleep 2
277                 echo "killing umount"
278                 kill -TERM $UMOUNT_PID
279                 echo "waiting for umount to finish"
280                 wait $UMOUNT_PID
281                 grep " $MOUNT " /proc/mounts && echo "test 5: /proc/mounts after second umount" && return 11
282         fi
283
284         manual_umount_client
285         # stop_mds is a no-op here, and should not fail
286         cleanup_nocli || return $?
287         # df may have lingering entry
288         manual_umount_client
289         # mtab may have lingering entry
290         local WAIT=0
291         local MAX_WAIT=20
292         local sleep=1
293         while [ "$WAIT" -ne "$MAX_WAIT" ]; do
294                 sleep $sleep
295                 grep -q $MOUNT" " /etc/mtab || break
296                 echo "Waiting /etc/mtab updated ... "
297                 WAIT=$(( WAIT + sleep))
298         done
299         [ "$WAIT" -eq "$MAX_WAIT" ] && error "/etc/mtab is not updated in $WAIT secs"
300         echo "/etc/mtab updated in $WAIT secs"
301 }
302 run_test 5a "force cleanup mds, then cleanup"
303
304 test_5b() {
305         start_ost
306         [ -d $MOUNT ] || mkdir -p $MOUNT
307         grep " $MOUNT " /etc/mtab && echo "test 5b: mtab before mount" && return 10
308         mount_client $MOUNT && return 1
309         grep " $MOUNT " /etc/mtab && echo "test 5b: mtab after failed mount" && return 11
310         umount_client $MOUNT
311         # stop_mds is a no-op here, and should not fail
312         cleanup_nocli || return $?
313         return 0
314 }
315 run_test 5b "mds down, cleanup after failed mount (bug 2712) (should return errs)"
316
317 test_5c() {
318         start_ost
319         start_mds
320         [ -d $MOUNT ] || mkdir -p $MOUNT
321         grep " $MOUNT " /etc/mtab && echo "test 5c: mtab before mount" && return 10
322         local oldfs="${FSNAME}"
323         FSNAME="wrong.${FSNAME}"
324         mount_client $MOUNT || :
325         FSNAME=${oldfs}
326         grep " $MOUNT " /etc/mtab && echo "test 5c: mtab after failed mount" && return 11
327         umount_client $MOUNT
328         cleanup_nocli  || return $?
329 }
330 run_test 5c "cleanup after failed mount (bug 2712) (should return errs)"
331
332 test_5d() {
333         start_ost
334         start_mds
335         stop_ost -f
336         grep " $MOUNT " /etc/mtab && echo "test 5d: mtab before mount" && return 10
337         mount_client $MOUNT || return 1
338         cleanup  || return $?
339         grep " $MOUNT " /etc/mtab && echo "test 5d: mtab after unmount" && return 11
340         return 0
341 }
342 run_test 5d "mount with ost down"
343
344 test_5e() {
345         start_ost
346         start_mds
347
348 #define OBD_FAIL_PTLRPC_DELAY_SEND       0x506
349         do_facet client "lctl set_param fail_loc=0x80000506"
350         grep " $MOUNT " /etc/mtab && echo "test 5e: mtab before mount" && return 10
351         mount_client $MOUNT || echo "mount failed (not fatal)"
352         cleanup  || return $?
353         grep " $MOUNT " /etc/mtab && echo "test 5e: mtab after unmount" && return 11
354         return 0
355 }
356 run_test 5e "delayed connect, don't crash (bug 10268)"
357
358 test_6() {
359         setup
360         manual_umount_client
361         mount_client ${MOUNT} || return 87
362         touch $DIR/a || return 86
363         cleanup  || return $?
364 }
365 run_test 6 "manual umount, then mount again"
366
367 test_7() {
368         setup
369         manual_umount_client
370         cleanup_nocli || return $?
371 }
372 run_test 7 "manual umount, then cleanup"
373
374 test_8() {
375         setup
376         mount_client $MOUNT2
377         check_mount2 || return 45
378         umount_client $MOUNT2
379         cleanup  || return $?
380 }
381 run_test 8 "double mount setup"
382
383 test_9() {
384         start_ost
385
386         do_facet ost1 lctl set_param debug=\'inode trace\' || return 1
387         do_facet ost1 lctl set_param subsystem_debug=\'mds ost\' || return 1
388
389         CHECK_PTLDEBUG="`do_facet ost1 lctl get_param -n debug`"
390         if [ "$CHECK_PTLDEBUG" ] && [ "$CHECK_PTLDEBUG" = "trace inode" ];then
391            echo "lnet.debug success"
392         else
393            echo "lnet.debug: want 'trace inode', have '$CHECK_PTLDEBUG'"
394            return 1
395         fi
396         CHECK_SUBSYS="`do_facet ost1 lctl get_param -n subsystem_debug`"
397         if [ "$CHECK_SUBSYS" ] && [ "$CHECK_SUBSYS" = "mds ost" ]; then
398            echo "lnet.subsystem_debug success"
399         else
400            echo "lnet.subsystem_debug: want 'mds ost', have '$CHECK_SUBSYS'"
401            return 1
402         fi
403         stop_ost || return $?
404 }
405
406 run_test 9 "test ptldebug and subsystem for mkfs"
407
408 test_16() {
409         local TMPMTPT="${TMP}/conf16"
410
411         if [ ! -e "$MDSDEV" ]; then
412             log "no $MDSDEV existing, so mount Lustre to create one"
413             setup
414             check_mount || return 41
415             cleanup || return $?
416         fi
417
418         [ -f "$MDSDEV" ] && LOOPOPT="-o loop"
419
420         log "change the mode of $MDSDEV/OBJECTS,LOGS,PENDING to 555"
421         do_facet mds "mkdir -p $TMPMTPT &&
422                       mount $LOOPOPT -t $FSTYPE $MDSDEV $TMPMTPT &&
423                       chmod 555 $TMPMTPT/{OBJECTS,LOGS,PENDING} &&
424                       umount $TMPMTPT" || return $?
425
426         log "mount Lustre to change the mode of OBJECTS/LOGS/PENDING, then umount Lustre"
427         setup
428         check_mount || return 41
429         cleanup || return $?
430
431         log "read the mode of OBJECTS/LOGS/PENDING and check if they has been changed properly"
432         EXPECTEDOBJECTSMODE=`do_facet mds "$DEBUGFS -R 'stat OBJECTS' $MDSDEV 2> /dev/null" | grep 'Mode: ' | sed -e "s/.*Mode: *//" -e "s/ *Flags:.*//"`
433         EXPECTEDLOGSMODE=`do_facet mds "$DEBUGFS -R 'stat LOGS' $MDSDEV 2> /dev/null" | grep 'Mode: ' | sed -e "s/.*Mode: *//" -e "s/ *Flags:.*//"`
434         EXPECTEDPENDINGMODE=`do_facet mds "$DEBUGFS -R 'stat PENDING' $MDSDEV 2> /dev/null" | grep 'Mode: ' | sed -e "s/.*Mode: *//" -e "s/ *Flags:.*//"`
435
436         if [ "$EXPECTEDOBJECTSMODE" = "0777" ]; then
437                 log "Success:Lustre change the mode of OBJECTS correctly"
438         else
439                 error "Lustre does not change mode of OBJECTS properly"
440         fi
441
442         if [ "$EXPECTEDLOGSMODE" = "0777" ]; then
443                 log "Success:Lustre change the mode of LOGS correctly"
444         else
445                 error "Lustre does not change mode of LOGS properly"
446         fi
447
448         if [ "$EXPECTEDPENDINGMODE" = "0777" ]; then
449                 log "Success:Lustre change the mode of PENDING correctly"
450         else
451                 error "Lustre does not change mode of PENDING properly"
452         fi
453 }
454 run_test 16 "verify that lustre will correct the mode of OBJECTS/LOGS/PENDING"
455
456 test_17() {
457         if [ ! -e "$MDSDEV" ]; then
458             echo "no $MDSDEV existing, so mount Lustre to create one"
459             setup
460             check_mount || return 41
461             cleanup || return $?
462         fi
463
464         echo "Remove mds config log"
465         do_facet mds "$DEBUGFS -w -R 'unlink CONFIGS/$FSNAME-MDT0000' $MDSDEV || return \$?" || return $?
466
467         start_ost
468         start_mds && return 42
469         reformat_and_config
470 }
471 run_test 17 "Verify failed mds_postsetup won't fail assertion (2936) (should return errs)"
472
473 test_18() {
474         [ "$FSTYPE" != "ldiskfs" ] && skip "not needed for FSTYPE=$FSTYPE" && return
475
476         local MIN=2000000
477
478         local OK=
479         # check if current MDSSIZE is large enough
480         [ $MDSSIZE -ge $MIN ] && OK=1 && myMDSSIZE=$MDSSIZE && \
481                 log "use MDSSIZE=$MDSSIZE"
482
483         # check if the global config has a large enough MDSSIZE
484         [ -z "$OK" -a ! -z "$STORED_MDSSIZE" ] && [ $STORED_MDSSIZE -ge $MIN ] && \
485                 OK=1 && myMDSSIZE=$STORED_MDSSIZE && \
486                 log "use STORED_MDSSIZE=$STORED_MDSSIZE"
487
488         # check if the block device is large enough
489         [ -z "$OK" -a -b $MDSDEV ] && \
490                 [ "$(dd if=$MDSDEV of=/dev/null bs=1k count=1 skip=$MIN 2>&1 |
491                      awk '($3 == "in") { print $1 }')" = "1+0" ] && OK=1 && \
492                 myMDSSIZE=$MIN && log "use device $MDSDEV with MIN=$MIN"
493
494         # check if a loopback device has enough space for fs metadata (5%)
495         [ -z "$OK" ] && [ -f $MDSDEV -o ! -e $MDSDEV ] &&
496                 SPACE=$(df -P $(dirname $MDSDEV) |
497                         awk '($1 != "Filesystem") {print $4}') &&
498                 [ $SPACE -gt $((MIN / 20)) ] && OK=1 && myMDSSIZE=$MIN && \
499                         log "use file $MDSDEV with MIN=$MIN"
500
501         [ -z "$OK" ] && skip "$MDSDEV too small for ${MIN}kB MDS" && return
502
503
504         echo "mount mds with large journal..."
505         local OLD_MDS_MKFS_OPTS=$MDS_MKFS_OPTS
506
507         MDS_MKFS_OPTS="--mgs --mdt --fsname=$FSNAME --device-size=$myMDSSIZE --param sys.timeout=$TIMEOUT $MDSOPT"
508
509         reformat_and_config
510         echo "mount lustre system..."
511         setup
512         check_mount || return 41
513
514         echo "check journal size..."
515         local FOUNDSIZE=`do_facet mds "$DEBUGFS -c -R 'stat <8>' $MDSDEV" | awk '/Size: / { print $NF; exit;}'`
516         if [ $FOUNDSIZE -gt $((32 * 1024 * 1024)) ]; then
517                 log "Success: mkfs creates large journals. Size: $((FOUNDSIZE >> 20))M"
518         else
519                 error "expected journal size > 32M, found $((FOUNDSIZE >> 20))M"
520         fi
521
522         cleanup || return $?
523
524         MDS_MKFS_OPTS=$OLD_MDS_MKFS_OPTS
525         reformat_and_config
526 }
527 run_test 18 "check mkfs creates large journals"
528
529 test_19a() {
530         start_mds || return 1
531         stop_mds -f || return 2
532 }
533 run_test 19a "start/stop MDS without OSTs"
534
535 test_19b() {
536         start_ost || return 1
537         stop_ost -f || return 2
538 }
539 run_test 19b "start/stop OSTs without MDS"
540
541 test_20() {
542         # first format the ost/mdt
543         start_ost
544         start_mds
545         mount_client $MOUNT
546         check_mount || return 43
547         rm -f $DIR/$tfile
548         remount_client ro $MOUNT || return 44
549         touch $DIR/$tfile && echo "$DIR/$tfile created incorrectly" && return 45
550         [ -e $DIR/$tfile ] && echo "$DIR/$tfile exists incorrectly" && return 46
551         remount_client rw $MOUNT || return 47
552         touch $DIR/$tfile
553         [ ! -f $DIR/$tfile ] && echo "$DIR/$tfile missing" && return 48
554         MCNT=`grep -c $MOUNT /etc/mtab`
555         [ "$MCNT" -ne 1 ] && echo "$MOUNT in /etc/mtab $MCNT times" && return 49
556         umount_client $MOUNT
557         stop_mds
558         stop_ost
559 }
560 run_test 20 "remount ro,rw mounts work and doesn't break /etc/mtab"
561
562 test_21a() {
563         start_mds
564         start_ost
565         wait_osc_import_state mds ost FULL
566         stop_ost
567         stop_mds
568 }
569 run_test 21a "start mds before ost, stop ost first"
570
571 test_21b() {
572         start_ost
573         start_mds
574         wait_osc_import_state mds ost FULL
575         stop_mds
576         stop_ost
577 }
578 run_test 21b "start ost before mds, stop mds first"
579
580 test_21c() {
581         start_ost
582         start_mds
583         start_ost2
584         wait_osc_import_state mds ost2 FULL
585
586         stop_ost
587         stop_ost2
588         stop_mds
589         #writeconf to remove all ost2 traces for subsequent tests
590         writeconf
591 }
592 run_test 21c "start mds between two osts, stop mds last"
593
594 test_22() {
595         start_mds
596
597         echo Client mount with ost in logs, but none running
598         start_ost
599         wait_osc_import_state mds ost FULL
600         stop_ost
601         mount_client $MOUNT
602         # check_mount will block trying to contact ost
603         umount_client $MOUNT
604         pass
605
606         echo Client mount with a running ost
607         start_ost
608         mount_client $MOUNT
609         check_mount || return 41
610         pass
611
612         cleanup
613 }
614 run_test 22 "start a client before osts (should return errs)"
615
616 test_23a() {    # was test_23
617         setup
618         # fail mds
619         stop mds
620         # force down client so that recovering mds waits for reconnect
621         local running=$(grep -c $MOUNT /proc/mounts) || true
622         if [ $running -ne 0 ]; then
623                 echo "Stopping client $MOUNT (opts: -f)"
624                 umount -f $MOUNT
625         fi
626
627         # enter recovery on mds
628         start_mds
629         # try to start a new client
630         mount_client $MOUNT &
631         sleep 5
632         MOUNT_PID=$(ps -ef | grep "t lustre" | grep -v grep | awk '{print $2}')
633         MOUNT_LUSTRE_PID=`ps -ef | grep mount.lustre | grep -v grep | awk '{print $2}'`
634         echo mount pid is ${MOUNT_PID}, mount.lustre pid is ${MOUNT_LUSTRE_PID}
635         ps --ppid $MOUNT_PID
636         ps --ppid $MOUNT_LUSTRE_PID
637         # FIXME why o why can't I kill these? Manual "ctrl-c" works...
638         kill -TERM $MOUNT_LUSTRE_PID
639         echo "waiting for mount to finish"
640         ps -ef | grep mount
641         # we can not wait $MOUNT_PID because it is not a child of this shell
642         local PID1
643         local PID2
644         local WAIT=0
645         local MAX_WAIT=20
646         local sleep=1
647         while [ "$WAIT" -lt "$MAX_WAIT" ]; do
648                 sleep $sleep
649                 PID1=$(ps -ef | awk '{print $2}' | grep -w $MOUNT_PID)
650                 PID2=$(ps -ef | awk '{print $2}' | grep -w $MOUNT_LUSTRE_PID)
651                 echo PID1=$PID1
652                 echo PID2=$PID2
653                 [ -z "$PID1" -a -z "$PID2" ] && break
654                 echo "waiting for mount to finish ... "
655                 WAIT=$(( WAIT + sleep))
656         done
657         [ "$WAIT" -eq "$MAX_WAIT" ] && error "MOUNT_PID $MOUNT_PID and \
658                 MOUNT__LUSTRE_PID $MOUNT__LUSTRE_PID still not killed in $WAIT secs"
659         ps -ef | grep mount
660         stop_mds || error
661         stop_ost || error
662 }
663 run_test 23a "interrupt client during recovery mount delay"
664
665 umount_client $MOUNT
666 cleanup_nocli
667
668 test_23b() {    # was test_23
669         start_ost
670         start_mds
671         # Simulate -EINTR during mount OBD_FAIL_LDLM_CLOSE_THREAD
672         lctl set_param fail_loc=0x80000313
673         mount_client $MOUNT
674         cleanup
675 }
676 run_test 23b "Simulate -EINTR during mount"
677
678 fs2mds_HOST=$mds_HOST
679 fs2ost_HOST=$ost_HOST
680
681 cleanup_24a() {
682         trap 0
683         echo "umount $MOUNT2 ..."
684         umount $MOUNT2 || true
685         echo "stopping fs2mds ..."
686         stop fs2mds -f || true
687         echo "stopping fs2ost ..."
688         stop fs2ost -f || true
689 }
690
691 test_24a() {
692         [ -n "$ost1_HOST" ] && fs2ost_HOST=$ost1_HOST
693         if [ -z "$fs2ost_DEV" -o -z "$fs2mds_DEV" ]; then
694                 do_facet mds [ -b "$MDSDEV" ] && \
695                 skip "mixed loopback and real device not working" && return
696         fi
697
698         local fs2mdsdev=${fs2mds_DEV:-${MDSDEV}_2}
699         local fs2ostdev=${fs2ost_DEV:-$(ostdevname 1)_2}
700
701         # test 8-char fsname as well
702         local FSNAME2=test1234
703         add fs2mds $MDS_MKFS_OPTS --fsname=${FSNAME2} --nomgs --mgsnode=$MGSNID --reformat $fs2mdsdev || exit 10
704
705         add fs2ost $OST_MKFS_OPTS --fsname=${FSNAME2} --reformat $fs2ostdev || exit 10
706
707         setup
708         start fs2mds $fs2mdsdev $MDS_MOUNT_OPTS && trap cleanup_24a EXIT INT
709         start fs2ost $fs2ostdev $OST_MOUNT_OPTS
710         mkdir -p $MOUNT2
711         mount -t lustre $MGSNID:/${FSNAME2} $MOUNT2 || return 1
712         # 1 still works
713         check_mount || return 2
714         # files written on 1 should not show up on 2
715         cp /etc/passwd $DIR/$tfile
716         sleep 10
717         [ -e $MOUNT2/$tfile ] && error "File bleed" && return 7
718         # 2 should work
719         cp /etc/passwd $MOUNT2/b || return 3
720         rm $MOUNT2/b || return 4
721         # 2 is actually mounted
722         grep $MOUNT2' ' /proc/mounts > /dev/null || return 5
723         # failover
724         facet_failover fs2mds
725         facet_failover fs2ost
726         df
727         umount_client $MOUNT
728         # the MDS must remain up until last MDT
729         stop_mds
730         MDS=$(do_facet mds "lctl get_param -n devices" | awk '($3 ~ "mdt" && $4 ~ "MDS") { print $4 }')
731         [ -z "$MDS" ] && error "No MDS" && return 8
732         cleanup_24a
733         cleanup_nocli || return 6
734 }
735 run_test 24a "Multiple MDTs on a single node"
736
737 test_24b() {
738         if [ -z "$fs2mds_DEV" ]; then
739                 do_facet mds [ -b "$MDSDEV" ] && \
740                 skip "mixed loopback and real device not working" && return
741         fi
742
743         local fs2mdsdev=${fs2mds_DEV:-${MDSDEV}_2}
744
745         add fs2mds $MDS_MKFS_OPTS --fsname=${FSNAME}2 --mgs --reformat $fs2mdsdev || exit 10
746         setup
747         start fs2mds $fs2mdsdev $MDS_MOUNT_OPTS && return 2
748         cleanup || return 6
749 }
750 run_test 24b "Multiple MGSs on a single node (should return err)"
751
752 test_25() {
753         setup
754         check_mount || return 2
755         local MODULES=$($LCTL modules | awk '{ print $2 }')
756         rmmod $MODULES 2>/dev/null || true
757         cleanup || return 6
758 }
759 run_test 25 "Verify modules are referenced"
760
761 test_26() {
762     load_modules
763     # we need modules before mount for sysctl, so make sure...
764     do_facet mds "lsmod | grep -q lustre || modprobe lustre"
765 #define OBD_FAIL_MDS_FS_SETUP            0x135
766     do_facet mds "lctl set_param fail_loc=0x80000135"
767     start_mds && echo MDS started && return 1
768     lctl get_param -n devices
769     DEVS=$(lctl get_param -n devices | wc -l)
770     [ $DEVS -gt 0 ] && return 2
771     unload_modules || return 203
772 }
773 run_test 26 "MDT startup failure cleans LOV (should return errs)"
774
775 set_and_check() {
776         local myfacet=$1
777         local TEST=$2
778         local PARAM=$3
779         local ORIG=$(do_facet $myfacet "$TEST")
780         if [ $# -gt 3 ]; then
781             local FINAL=$4
782         else
783             local -i FINAL
784             FINAL=$(($ORIG + 5))
785         fi
786         echo "Setting $PARAM from $ORIG to $FINAL"
787         do_facet mds "$LCTL conf_param $PARAM=$FINAL" || error conf_param failed
788
789         wait_update $(facet_host $myfacet) "$TEST" $FINAL || error check failed!
790 }
791
792 test_27a() {
793         start_ost || return 1
794         start_mds || return 2
795         echo "Requeue thread should have started: "
796         ps -e | grep ll_cfg_requeue
797         set_and_check ost1 "lctl get_param -n obdfilter.$FSNAME-OST0000.client_cache_seconds" "$FSNAME-OST0000.ost.client_cache_seconds" || return 3
798         cleanup_nocli
799 }
800 run_test 27a "Reacquire MGS lock if OST started first"
801
802 test_27b() {
803         setup
804         facet_failover mds
805         set_and_check mds "lctl get_param -n mds.$FSNAME-MDT0000.group_acquire_expire" "$FSNAME-MDT0000.mdt.group_acquire_expire" || return 3
806         set_and_check client "lctl get_param -n mdc.$FSNAME-MDT0000-mdc-*.max_rpcs_in_flight" "$FSNAME-MDT0000.mdc.max_rpcs_in_flight" || return 4
807         check_mount
808         cleanup
809 }
810 run_test 27b "Reacquire MGS lock after failover"
811
812 test_28() {
813         setup
814         TEST="lctl get_param -n llite.$FSNAME-*.max_read_ahead_whole_mb"
815         PARAM="$FSNAME.llite.max_read_ahead_whole_mb"
816         ORIG=$($TEST)
817         FINAL=$(($ORIG + 1))
818         set_and_check client "$TEST" "$PARAM" $FINAL || return 3
819         FINAL=$(($FINAL + 1))
820         set_and_check client "$TEST" "$PARAM" $FINAL || return 4
821         umount_client $MOUNT || return 200
822         mount_client $MOUNT
823         RESULT=$($TEST)
824         if [ $RESULT -ne $FINAL ]; then
825             echo "New config not seen: wanted $FINAL got $RESULT"
826             return 4
827         else
828             echo "New config success: got $RESULT"
829         fi
830         set_and_check client "$TEST" "$PARAM" $ORIG || return 5
831         cleanup
832 }
833 run_test 28 "permanent parameter setting"
834
835 test_29() {
836         [ "$OSTCOUNT" -lt "2" ] && skip "$OSTCOUNT < 2, skipping" && return
837         setup > /dev/null 2>&1
838         start_ost2
839         sleep 10
840
841         local PARAM="$FSNAME-OST0001.osc.active"
842         local PROC_ACT="osc.$FSNAME-OST0001-osc-*.active"
843         local PROC_UUID="osc.$FSNAME-OST0001-osc-*.ost_server_uuid"
844
845         ACTV=$(lctl get_param -n $PROC_ACT)
846         DEAC=$((1 - $ACTV))
847         set_and_check client "lctl get_param -n $PROC_ACT" "$PARAM" $DEAC || return 2
848         # also check ost_server_uuid status
849         RESULT=$(lctl get_param -n $PROC_UUID | grep DEACTIV)
850         if [ -z "$RESULT" ]; then
851             echo "Live client not deactivated: $(lctl get_param -n $PROC_UUID)"
852             return 3
853         else
854             echo "Live client success: got $RESULT"
855         fi
856
857         # check MDT too
858         local MPROC="osc.$FSNAME-OST0001-osc.active"
859         local MAX=30
860         local WAIT=0
861         while [ 1 ]; do
862             sleep 5
863             RESULT=`do_facet mds " lctl get_param -n $MPROC"`
864             [ ${PIPESTATUS[0]} = 0 ] || error "Can't read $MPROC"
865             if [ $RESULT -eq $DEAC ]; then
866                 echo "MDT deactivated also after $WAIT sec (got $RESULT)"
867                 break
868             fi
869             WAIT=$((WAIT + 5))
870             if [ $WAIT -eq $MAX ]; then
871                 echo "MDT not deactivated: wanted $DEAC got $RESULT"
872                 return 4
873             fi
874             echo "Waiting $(($MAX - $WAIT)) secs for MDT deactivated"
875         done
876
877         # test new client starts deactivated
878         umount_client $MOUNT || return 200
879         mount_client $MOUNT
880         RESULT=$(lctl get_param -n $PROC_UUID | grep DEACTIV | grep NEW)
881         if [ -z "$RESULT" ]; then
882             echo "New client not deactivated from start: $(lctl get_param -n $PROC_UUID)"
883             return 5
884         else
885             echo "New client success: got $RESULT"
886         fi
887
888         # make sure it reactivates
889         set_and_check client "lctl get_param -n $PROC_ACT" "$PARAM" $ACTV || return 6
890
891         umount_client $MOUNT
892         stop_ost2
893         cleanup_nocli
894         #writeconf to remove all ost2 traces for subsequent tests
895         writeconf
896 }
897 run_test 29 "permanently remove an OST"
898
899 test_30() {
900         setup
901
902         TEST="lctl get_param -n llite.$FSNAME-*.max_read_ahead_whole_mb"
903         ORIG=$($TEST)
904         LIST=(1 2 3 4 5 4 3 2 1 2 3 4 5 4 3 2 1 2 3 4 5)
905         for i in ${LIST[@]}; do
906             set_and_check client "$TEST" "$FSNAME.llite.max_read_ahead_whole_mb" $i || return 3
907         done
908         # make sure client restart still works
909         umount_client $MOUNT
910         mount_client $MOUNT || return 4
911         [ "$($TEST)" -ne "$i" ] && return 5
912         set_and_check client "$TEST" "$FSNAME.llite.max_read_ahead_whole_mb" $ORIG || return 6
913         cleanup
914 }
915 run_test 30 "Big config llog"
916
917 test_31() { # bug 10734
918         # ipaddr must not exist
919         mount -t lustre 4.3.2.1@tcp:/lustre $MOUNT || true
920         cleanup
921 }
922 run_test 31 "Connect to non-existent node (returns errors, should not crash)"
923
924 # Use these start32/stop32 fn instead of t-f start/stop fn,
925 # for local devices, to skip global facet vars init
926 stop32 () {
927         local facet=$1
928         shift
929         echo "Stopping local ${MOUNT%/*}/${facet} (opts:$@)"
930         umount -d $@ ${MOUNT%/*}/${facet}
931         losetup -a
932 }
933
934 start32 () {
935         local facet=$1
936         shift
937         local device=$1
938         shift
939         mkdir -p ${MOUNT%/*}/${facet}
940
941         echo "Starting local ${facet}: $@ $device ${MOUNT%/*}/${facet}"
942         mount -t lustre $@ ${device} ${MOUNT%/*}/${facet}
943         RC=$?
944         if [ $RC -ne 0 ]; then
945                 echo "mount -t lustre $@ ${device} ${MOUNT%/*}/${facet}"
946                 echo "Start of ${device} of local ${facet} failed ${RC}"
947         fi
948         losetup -a
949         return $RC
950 }
951
952 cleanup_nocli32 () {
953         stop32 mds -f
954         stop32 ost1 -f
955         wait_exit_ST client
956 }
957
958 cleanup_32() {
959         trap 0
960         echo "Cleanup test_32 umount $MOUNT ..."
961         umount -f $MOUNT || true
962         echo "Cleanup local mds ost1 ..."
963         cleanup_nocli32
964         unload_modules
965 }
966
967 test_32a() {
968         # this test is totally useless on a client-only system
969         [ -n "$CLIENTONLY" -o -n "$CLIENTMODSONLY" ] && skip "client only testing" && return 0
970         [ "$NETTYPE" = "tcp" ] || { skip "NETTYPE != tcp" && return 0; }
971         [ -z "$TUNEFS" ] && skip "No tunefs" && return 0
972
973         local DISK1_4=$LUSTRE/tests/disk1_4.zip
974         [ ! -r $DISK1_4 ] && skip "Cant find $DISK1_4, skipping" && return
975
976         local tmpdir=$TMP/conf32a
977         unzip -o -j -d $tmpdir $DISK1_4 || { skip "Cant unzip $DISK1_4, skipping" && return ; }
978         load_modules
979         lctl set_param debug=$PTLDEBUG
980
981         $TUNEFS $tmpdir/mds || error "tunefs failed"
982
983         # nids are wrong, so client wont work, but server should start
984         start32 mds $tmpdir/mds "-o loop,exclude=lustre-OST0000" && \
985                 trap cleanup_32 EXIT INT || return 3
986
987         local UUID=$(lctl get_param -n mds.lustre-MDT0000.uuid)
988         echo MDS uuid $UUID
989         [ "$UUID" == "mdsA_UUID" ] || error "UUID is wrong: $UUID"
990
991         $TUNEFS --mgsnode=`hostname` $tmpdir/ost1 || error "tunefs failed"
992         start32 ost1 $tmpdir/ost1 "-o loop" || return 5
993         UUID=$(lctl get_param -n obdfilter.lustre-OST0000.uuid)
994         echo OST uuid $UUID
995         [ "$UUID" == "ost1_UUID" ] || error "UUID is wrong: $UUID"
996
997         local NID=$($LCTL list_nids | head -1)
998
999         echo "OSC changes should return err:"
1000         $LCTL conf_param lustre-OST0000.osc.max_dirty_mb=15 && return 7
1001         $LCTL conf_param lustre-OST0000.failover.node=$NID && return 8
1002         echo "ok."
1003         echo "MDC changes should succeed:"
1004         $LCTL conf_param lustre-MDT0000.mdc.max_rpcs_in_flight=9 || return 9
1005         $LCTL conf_param lustre-MDT0000.failover.node=$NID || return 10
1006         echo "ok."
1007
1008         cleanup_32
1009
1010         # mount a second time to make sure we didnt leave upgrade flag on
1011         load_modules
1012         $TUNEFS --dryrun $tmpdir/mds || error "tunefs failed"
1013         start32 mds $tmpdir/mds "-o loop,exclude=lustre-OST0000" && \
1014                 trap cleanup_32 EXIT INT || return 12
1015
1016         cleanup_32
1017
1018         rm -rf $tmpdir || true  # true is only for TMP on NFS
1019 }
1020 run_test 32a "Upgrade from 1.4 (not live)"
1021
1022 test_32b() {
1023         # this test is totally useless on a client-only system
1024         [ -n "$CLIENTONLY" -o -n "$CLIENTMODSONLY" ] && skip "client only testing" && return 0
1025         [ "$NETTYPE" = "tcp" ] || { skip "NETTYPE != tcp" && return 0; }
1026         [ -z "$TUNEFS" ] && skip "No tunefs" && return
1027
1028         local DISK1_4=$LUSTRE/tests/disk1_4.zip
1029         [ ! -r $DISK1_4 ] && skip "Cant find $DISK1_4, skipping" && return
1030
1031         local tmpdir=$TMP/conf32b
1032         unzip -o -j -d $tmpdir $DISK1_4 || { skip "Cant unzip $DISK1_4, skipping" && return ; }
1033         load_modules
1034         lctl set_param debug=$PTLDEBUG
1035         local NEWNAME=sofia
1036
1037         # writeconf will cause servers to register with their current nids
1038         $TUNEFS --writeconf --fsname=$NEWNAME $tmpdir/mds || error "tunefs failed"
1039         start32 mds $tmpdir/mds "-o loop" && \
1040                 trap cleanup_32 EXIT INT || return 3
1041
1042         local UUID=$(lctl get_param -n mds.${NEWNAME}-MDT0000.uuid)
1043         echo MDS uuid $UUID
1044         [ "$UUID" == "mdsA_UUID" ] || error "UUID is wrong: $UUID"
1045
1046         $TUNEFS --mgsnode=`hostname` --fsname=$NEWNAME --writeconf $tmpdir/ost1 || error "tunefs failed"
1047         start32 ost1 $tmpdir/ost1 "-o loop" || return 5
1048         UUID=$(lctl get_param -n obdfilter.${NEWNAME}-OST0000.uuid)
1049         echo OST uuid $UUID
1050         [ "$UUID" == "ost1_UUID" ] || error "UUID is wrong: $UUID"
1051
1052         echo "OSC changes should succeed:"
1053         $LCTL conf_param ${NEWNAME}-OST0000.osc.max_dirty_mb=15 || return 7
1054         $LCTL conf_param ${NEWNAME}-OST0000.failover.node=$NID || return 8
1055         echo "ok."
1056         echo "MDC changes should succeed:"
1057         $LCTL conf_param ${NEWNAME}-MDT0000.mdc.max_rpcs_in_flight=9 || return 9
1058         echo "ok."
1059
1060         # MDT and OST should have registered with new nids, so we should have
1061         # a fully-functioning client
1062         echo "Check client and old fs contents"
1063
1064         local device=`h2$NETTYPE $HOSTNAME`:/$NEWNAME
1065         echo "Starting local client: $HOSTNAME: $device $MOUNT"
1066         mount -t lustre $device $MOUNT || return 1
1067
1068         local old=$(lctl get_param -n mdc.*.max_rpcs_in_flight)
1069         local new=$((old + 5))
1070         lctl conf_param ${NEWNAME}-MDT0000.mdc.max_rpcs_in_flight=$new
1071         wait_update $HOSTNAME "lctl get_param -n mdc.*.max_rpcs_in_flight" $new || return 11
1072
1073         [ "$(cksum $MOUNT/passwd | cut -d' ' -f 1,2)" == "2479747619 779" ] || return 12
1074         echo "ok."
1075
1076         cleanup_32
1077
1078         rm -rf $tmpdir || true  # true is only for TMP on NFS
1079 }
1080 run_test 32b "Upgrade from 1.4 with writeconf"
1081
1082 test_33a() { # bug 12333, was test_33
1083         local rc=0
1084         local FSNAME2=test-123
1085         [ -n "$ost1_HOST" ] && fs2ost_HOST=$ost1_HOST
1086
1087         if [ -z "$fs2ost_DEV" -o -z "$fs2mds_DEV" ]; then
1088                 do_facet mds [ -b "$MDSDEV" ] && \
1089                 skip "mixed loopback and real device not working" && return
1090         fi
1091
1092         local fs2mdsdev=${fs2mds_DEV:-${MDSDEV}_2}
1093         local fs2ostdev=${fs2ost_DEV:-$(ostdevname 1)_2}
1094         add fs2mds $MDS_MKFS_OPTS --fsname=${FSNAME2} --reformat $fs2mdsdev || exit 10
1095         add fs2ost $OST_MKFS_OPTS --fsname=${FSNAME2} --index=8191 --mgsnode=$MGSNID --reformat $fs2ostdev || exit 10
1096
1097         start fs2mds $fs2mdsdev $MDS_MOUNT_OPTS && trap cleanup_24a EXIT INT
1098         start fs2ost $fs2ostdev $OST_MOUNT_OPTS
1099         do_facet mds "$LCTL conf_param $FSNAME2.sys.timeout=200" || rc=1
1100         mkdir -p $MOUNT2
1101         mount -t lustre $MGSNID:/${FSNAME2} $MOUNT2 || rc=2
1102         cp /etc/hosts $MOUNT2/. || rc=3
1103         echo "ok."
1104
1105         cp /etc/hosts $MOUNT2/ || rc=3
1106         $LFS getstripe $MOUNT2/hosts
1107
1108         umount -d $MOUNT2
1109         stop fs2ost -f
1110         stop fs2mds -f
1111         rm -rf $MOUNT2 $fs2mdsdev $fs2ostdev
1112         cleanup_nocli || rc=6
1113         return $rc
1114 }
1115 run_test 33a "Mount ost with a large index number"
1116
1117 test_33b() {    # was test_33a
1118         setup
1119
1120         do_facet client dd if=/dev/zero of=$MOUNT/24 bs=1024k count=1
1121         # Drop lock cancelation reply during umount
1122         #define OBD_FAIL_LDLM_CANCEL             0x304
1123         do_facet client lctl set_param fail_loc=0x80000304
1124         #lctl set_param debug=-1
1125         umount_client $MOUNT
1126         cleanup
1127 }
1128 run_test 33b "Drop cancel during umount"
1129
1130 test_34a() {
1131         setup
1132         do_facet client "sh runmultiop_bg_pause $DIR/file O_c"
1133         manual_umount_client
1134         rc=$?
1135         do_facet client killall -USR1 multiop
1136         if [ $rc -eq 0 ]; then
1137                 error "umount not fail!"
1138         fi
1139         sleep 1
1140         cleanup
1141 }
1142 run_test 34a "umount with opened file should be fail"
1143
1144
1145 test_34b() {
1146         setup
1147         touch $DIR/$tfile || return 1
1148         stop_mds --force || return 2
1149
1150         manual_umount_client --force
1151         rc=$?
1152         if [ $rc -ne 0 ]; then
1153                 error "mtab after failed umount - rc $rc"
1154         fi
1155
1156         cleanup
1157         return 0
1158 }
1159 run_test 34b "force umount with failed mds should be normal"
1160
1161 test_34c() {
1162         setup
1163         touch $DIR/$tfile || return 1
1164         stop_ost --force || return 2
1165
1166         manual_umount_client --force
1167         rc=$?
1168         if [ $rc -ne 0 ]; then
1169                 error "mtab after failed umount - rc $rc"
1170         fi
1171
1172         cleanup
1173         return 0
1174 }
1175 run_test 34c "force umount with failed ost should be normal"
1176
1177 test_35() { # bug 12459
1178         setup
1179
1180         debugsave
1181         lctl set_param debug="ha"
1182
1183         log "Set up a fake failnode for the MDS"
1184         FAKENID="127.0.0.2"
1185         do_facet mds $LCTL conf_param ${FSNAME}-MDT0000.failover.node=$FAKENID || return 4
1186
1187         log "Wait for RECONNECT_INTERVAL seconds (10s)"
1188         sleep 10
1189
1190         MSG="conf-sanity.sh test_35 `date +%F%kh%Mm%Ss`"
1191         $LCTL clear
1192         log "$MSG"
1193         log "Stopping the MDT:"
1194         stop_mds || return 5
1195
1196         df $MOUNT > /dev/null 2>&1 &
1197         DFPID=$!
1198         log "Restarting the MDT:"
1199         start_mds || return 6
1200         log "Wait for df ($DFPID) ... "
1201         wait $DFPID
1202         log "done"
1203         debugrestore
1204
1205         # retrieve from the log the first server that the client tried to
1206         # contact after the connection loss
1207         $LCTL dk $TMP/lustre-log-$TESTNAME.log
1208         NEXTCONN=`awk "/${MSG}/ {start = 1;}
1209                        /import_select_connection.*${FSNAME}-MDT0000-mdc.* using connection/ {
1210                                 if (start) {
1211                                         if (\\\$NF ~ /$FAKENID/)
1212                                                 print \\\$NF;
1213                                         else
1214                                                 print 0;
1215                                         exit;
1216                                 }
1217                        }" $TMP/lustre-log-$TESTNAME.log`
1218         [ "$NEXTCONN" != "0" ] && log "The client didn't try to reconnect to the last active server (tried ${NEXTCONN} instead)" && return 7
1219         cleanup
1220 }
1221 run_test 35 "Reconnect to the last active server first"
1222
1223 test_36() { # 12743
1224         local rc
1225         local FSNAME2=test1234
1226         local fs3ost_HOST=$ost_HOST
1227
1228         [ -n "$ost1_HOST" ] && fs2ost_HOST=$ost1_HOST && fs3ost_HOST=$ost1_HOST
1229         rc=0
1230
1231         if [ -z "$fs2ost_DEV" -o -z "$fs2mds_DEV" -o -z "$fs3ost_DEV" ]; then
1232                 do_facet mds [ -b "$MDSDEV" ] && \
1233                 skip "mixed loopback and real device not working" && return
1234         fi
1235         [ $OSTCOUNT -lt 2 ] && skip "skipping test for single OST" && return
1236
1237         [ "$ost_HOST" = "`hostname`" -o "$ost1_HOST" = "`hostname`" ] || \
1238                 { skip "remote OST" && return 0; }
1239
1240         local fs2mdsdev=${fs2mds_DEV:-${MDSDEV}_2}
1241         local fs2ostdev=${fs2ost_DEV:-$(ostdevname 1)_2}
1242         local fs3ostdev=${fs3ost_DEV:-$(ostdevname 2)_2}
1243         add fs2mds $MDS_MKFS_OPTS --fsname=${FSNAME2} --reformat $fs2mdsdev || exit 10
1244         # XXX after we support non 4K disk blocksize, change following --mkfsoptions with
1245         # other argument
1246         add fs2ost $OST_MKFS_OPTS --mkfsoptions='-b4096' --fsname=${FSNAME2} --mgsnode=$MGSNID --reformat $fs2ostdev || exit 10
1247         add fs3ost $OST_MKFS_OPTS --mkfsoptions='-b4096' --fsname=${FSNAME2} --mgsnode=$MGSNID --reformat $fs3ostdev || exit 10
1248
1249         start fs2mds $fs2mdsdev $MDS_MOUNT_OPTS
1250         start fs2ost $fs2ostdev $OST_MOUNT_OPTS
1251         start fs3ost $fs3ostdev $OST_MOUNT_OPTS
1252         mkdir -p $MOUNT2
1253         mount -t lustre $MGSNID:/${FSNAME2} $MOUNT2 || return 1
1254
1255         sleep 5 # until 11778 fixed
1256
1257         dd if=/dev/zero of=$MOUNT2/$tfile bs=1M count=7 || return 2
1258
1259         BKTOTAL=`lctl get_param -n obdfilter.*.kbytestotal | awk 'BEGIN{total=0}; {total+=$1}; END{print total}'`
1260         BKFREE=`lctl get_param -n obdfilter.*.kbytesfree | awk 'BEGIN{free=0}; {free+=$1}; END{print free}'`
1261         BKAVAIL=`lctl get_param -n obdfilter.*.kbytesavail | awk 'BEGIN{avail=0}; {avail+=$1}; END{print avail}'`
1262         STRING=`df -P $MOUNT2 | tail -n 1 | awk '{print $2","$3","$4}'`
1263         DFTOTAL=`echo $STRING | cut -d, -f1`
1264         DFUSED=`echo $STRING  | cut -d, -f2`
1265         DFAVAIL=`echo $STRING | cut -d, -f3`
1266         DFFREE=$(($DFTOTAL - $DFUSED))
1267
1268         ALLOWANCE=$((64 * $OSTCOUNT))
1269
1270         if [ $DFTOTAL -lt $(($BKTOTAL - $ALLOWANCE)) ] ||
1271            [ $DFTOTAL -gt $(($BKTOTAL + $ALLOWANCE)) ] ; then
1272                 echo "**** FAIL: df total($DFTOTAL) mismatch OST total($BKTOTAL)"
1273                 rc=1
1274         fi
1275         if [ $DFFREE -lt $(($BKFREE - $ALLOWANCE)) ] ||
1276            [ $DFFREE -gt $(($BKFREE + $ALLOWANCE)) ] ; then
1277                 echo "**** FAIL: df free($DFFREE) mismatch OST free($BKFREE)"
1278                 rc=2
1279         fi
1280         if [ $DFAVAIL -lt $(($BKAVAIL - $ALLOWANCE)) ] ||
1281            [ $DFAVAIL -gt $(($BKAVAIL + $ALLOWANCE)) ] ; then
1282                 echo "**** FAIL: df avail($DFAVAIL) mismatch OST avail($BKAVAIL)"
1283                 rc=3
1284        fi
1285
1286         umount -d $MOUNT2
1287         stop fs3ost -f || return 200
1288         stop fs2ost -f || return 201
1289         stop fs2mds -f || return 202
1290         rm -rf $MOUNT2 $fs2mdsdev $fs2ostdev $fs3ostdev
1291         unload_modules || return 203
1292         return $rc
1293 }
1294 run_test 36 "df report consistency on OSTs with different block size"
1295
1296 test_37() {
1297         [ -n "$CLIENTONLY" -o -n "$CLIENTMODSONLY" ] && skip "client only testing" && return 0
1298         LOCAL_MDSDEV="$TMP/mdt.img"
1299         SYM_MDSDEV="$TMP/sym_mdt.img"
1300
1301         echo "MDS :     $LOCAL_MDSDEV"
1302         echo "SYMLINK : $SYM_MDSDEV"
1303         rm -f $LOCAL_MDSDEV
1304
1305         touch $LOCAL_MDSDEV
1306         mkfs.lustre --reformat --fsname=lustre --mdt --mgs --device-size=9000 $LOCAL_MDSDEV ||
1307                 error "mkfs.lustre $LOCAL_MDSDEV failed"
1308         ln -s $LOCAL_MDSDEV $SYM_MDSDEV
1309
1310         echo "mount symlink device - $SYM_MDSDEV"
1311
1312         mount_op=`mount -v -t lustre -o loop $SYM_MDSDEV ${MOUNT%/*}/mds 2>&1 | grep "unable to set tunable"`
1313         umount -d ${MOUNT%/*}/mds
1314         rm -f $LOCAL_MDSDEV $SYM_MDSDEV
1315
1316         if [ -n "$mount_op" ]; then
1317                 error "**** FAIL: set tunables failed for symlink device"
1318         fi
1319         return 0
1320 }
1321 run_test 37 "verify set tunables works for symlink device"
1322
1323 test_38() { # bug 14222
1324         setup
1325         # like runtests
1326         COUNT=10
1327         SRC="/etc /bin"
1328         FILES=`find $SRC -type f -mtime +1 | head -n $COUNT`
1329         log "copying $(echo $FILES | wc -w) files to $DIR/$tdir"
1330         mkdir -p $DIR/$tdir
1331         tar cf - $FILES | tar xf - -C $DIR/$tdir || \
1332                 error "copying $SRC to $DIR/$tdir"
1333         sync
1334         umount_client $MOUNT
1335         stop_mds
1336         log "rename lov_objid file on MDS"
1337         rm -f $TMP/lov_objid.orig
1338         do_facet mds "$DEBUGFS -c -R \\\"dump lov_objid $TMP/lov_objid.orig\\\" $MDSDEV"
1339         do_facet mds "$DEBUGFS -w -R \\\"rm lov_objid\\\" $MDSDEV"
1340
1341         do_facet mds "od -Ax -td8 $TMP/lov_objid.orig"
1342         # check create in mds_lov_connect
1343         start_mds
1344         mount_client $MOUNT
1345         for f in $FILES; do
1346                 [ $V ] && log "verifying $DIR/$tdir/$f"
1347                 diff -q $f $DIR/$tdir/$f || ERROR=y
1348         done
1349         do_facet mds "$DEBUGFS -c -R \\\"dump lov_objid $TMP/lov_objid.new\\\"  $MDSDEV"
1350         do_facet mds "od -Ax -td8 $TMP/lov_objid.new"
1351         [ "$ERROR" = "y" ] && error "old and new files are different after connect" || true
1352
1353
1354         # check it's updates in sync
1355         umount_client $MOUNT
1356         stop_mds
1357
1358         do_facet mds dd if=/dev/zero of=$TMP/lov_objid.clear bs=4096 count=1
1359         do_facet mds "$DEBUGFS -w -R \\\"rm lov_objid\\\" $MDSDEV"
1360         do_facet mds "$DEBUGFS -w -R \\\"write $TMP/lov_objid.clear lov_objid\\\" $MDSDEV "
1361
1362         start_mds
1363         mount_client $MOUNT
1364         for f in $FILES; do
1365                 [ $V ] && log "verifying $DIR/$tdir/$f"
1366                 diff -q $f $DIR/$tdir/$f || ERROR=y
1367         done
1368         do_facet mds "$DEBUGFS -c -R \\\"dump lov_objid $TMP/lov_objid.new1\\\" $MDSDEV"
1369         do_facet mds "od -Ax -td8 $TMP/lov_objid.new1"
1370         umount_client $MOUNT
1371         stop_mds
1372         [ "$ERROR" = "y" ] && error "old and new files are different after sync" || true
1373
1374         log "files compared the same"
1375         cleanup
1376 }
1377 run_test 38 "MDS recreates missing lov_objid file from OST data"
1378
1379 test_39() { #bug 14413
1380         PTLDEBUG=+malloc
1381         setup
1382         cleanup
1383         perl $SRCDIR/leak_finder.pl $TMP/debug 2>&1 | egrep '*** Leak:' &&
1384                 error "memory leak detected" || true
1385 }
1386 run_test 39 "leak_finder recognizes both LUSTRE and LNET malloc messages"
1387
1388 test_40() { # bug 15759
1389         start_ost
1390         #define OBD_FAIL_TGT_TOOMANY_THREADS     0x706
1391         do_facet mds "lctl set_param fail_loc=0x80000706"
1392         start_mds
1393         cleanup
1394 }
1395 run_test 40 "race during service thread startup"
1396
1397 test_41() { #bug 14134
1398         local rc
1399         start mds $MDSDEV $MDS_MOUNT_OPTS -o nosvc -n
1400         start ost1 `ostdevname 1` $OST_MOUNT_OPTS
1401         start mds $MDSDEV $MDS_MOUNT_OPTS -o nomgs,force
1402         mkdir -p $MOUNT
1403         mount_client $MOUNT || return 1
1404         sleep 5
1405
1406         echo "blah blah" > $MOUNT/$tfile
1407         cat $MOUNT/$tfile
1408
1409         umount_client $MOUNT
1410         stop ost1 -f || return 201
1411         stop mds -f || return 202
1412         stop mds -f || return 203
1413         unload_modules || return 204
1414         return $rc
1415 }
1416 run_test 41 "mount mds with --nosvc and --nomgs"
1417
1418 test_42() { #bug 14693
1419         setup
1420         check_mount || return 2
1421         do_facet client lctl conf_param lustre.llite.some_wrong_param=10
1422         umount_client $MOUNT
1423         mount_client $MOUNT || return 1
1424         cleanup
1425         return 0
1426 }
1427 run_test 42 "invalid config param should not prevent client from mounting"
1428
1429 test_43() { #bug 15993
1430         setup
1431         VERSION_1_8=$(do_facet mds $LCTL get_param version | grep ^lustre.*1\.[78])
1432         if [ -z "$VERSION_1_8" ]; then
1433                 skip "skipping test for non 1.8 MDS"
1434                 cleanup
1435                 return 0
1436         fi
1437
1438         check_mount || return 2
1439         testfile=$DIR/$tfile
1440         lma="this-should-be-removed-after-remount-and-accessed"
1441         touch $testfile
1442         echo "set/get trusted.lma"
1443 #define OBD_FAIL_MDS_ALLOW_COMMON_EA_SETTING    0x13f
1444         do_facet mds "lctl set_param fail_loc=0x13f"
1445         lctl set_param fail_loc=0x13f
1446         setfattr -n trusted.lma -v $lma $testfile || error "create common EA"
1447         do_facet mds "lctl set_param fail_loc=0"
1448         lctl set_param fail_loc=0
1449         ATTR=$(getfattr -n trusted.lma $testfile 2> /dev/null | grep trusted.lma)
1450         [ "$ATTR" = "trusted.lma=\"$lma\"" ] || error "check common EA"
1451         umount_client $MOUNT
1452         stop_mds
1453         sleep 5
1454         start_mds
1455         mount_client $MOUNT
1456         check_mount || return 3
1457 #define OBD_FAIL_MDS_REMOVE_COMMON_EA    0x13e
1458         do_facet mds "lctl set_param fail_loc=0x13e"
1459         stat $testfile
1460         do_facet mds "lctl set_param fail_loc=0"
1461         getfattr -d -m trusted $testfile 2> /dev/null | \
1462             grep "trusted.lma" && error "common EA not removed" || true
1463         cleanup
1464         return 0
1465 }
1466 run_test 43 "remove common EA if it exists"
1467
1468 test_44() { # 16317
1469         setup
1470         check_mount || return 2
1471         UUID=$($LCTL get_param llite.${FSNAME}*.uuid | cut -d= -f2)
1472         STATS_FOUND=no
1473         UUIDS=$(do_facet mds "$LCTL get_param mds.${FSNAME}*.exports.*.uuid")
1474         for VAL in $UUIDS; do
1475                 NID=$(echo $VAL | cut -d= -f1)
1476                 CLUUID=$(echo $VAL | cut -d= -f2)
1477                 [ "$UUID" = "$CLUUID" ] && STATS_FOUND=yes && break
1478         done
1479         [ "$STATS_FOUND" = "no" ] && error "stats not found for client"
1480         cleanup
1481         return 0
1482 }
1483 run_test 44 "mounted client proc entry exists"
1484
1485 test_45() { #17310
1486         setup
1487         check_mount || return 2
1488         stop_mds
1489         df -h $MOUNT &
1490         log "sleep 60 sec"
1491         sleep 60
1492 #define OBD_FAIL_PTLRPC_LONG_UNLINK   0x50f
1493         do_facet client "lctl set_param fail_loc=0x50f"
1494         log "sleep 10 sec"
1495         sleep 10
1496         manual_umount_client --force || return 3
1497         do_facet client "lctl set_param fail_loc=0x0"
1498         start_mds
1499         mount_client $MOUNT || return 4
1500         cleanup
1501         return 0
1502 }
1503 run_test 45 "long unlink handling in ptlrpcd"
1504
1505 test_46a() {
1506         OSTCOUNT=6
1507         reformat
1508         start_mds || return 1
1509         #first client should see only one ost
1510         start_ost || return 2
1511         wait_osc_import_state mds ost FULL
1512         #start_client
1513         mount_client $MOUNT || return 3
1514
1515         start_ost2 || return 4
1516         start ost3 `ostdevname 3` $OST_MOUNT_OPTS || return 5
1517         start ost4 `ostdevname 4` $OST_MOUNT_OPTS || return 6
1518         start ost5 `ostdevname 5` $OST_MOUNT_OPTS || return 7
1519         wait_osc_import_state mds ost2 FULL
1520         wait_osc_import_state mds ost3 FULL
1521         wait_osc_import_state mds ost4 FULL
1522         wait_osc_import_state mds ost5 FULL
1523         #second client see all ost's
1524
1525         mount_client $MOUNT2 || return 8
1526         $LFS setstripe $MOUNT2 -c -1 || return 9
1527         $LFS getstripe $MOUNT2 || return 10
1528
1529         echo "ok" > $MOUNT2/widestripe
1530         $LFS getstripe $MOUNT2/widestripe || return 11
1531         # fill acl buffer for avoid expand lsm to them
1532         awk -F : '{if (FNR < 25) { print "u:"$1":rwx" }}' /etc/passwd | while read acl; do
1533             setfacl -m $acl $MOUNT2/widestripe
1534         done
1535
1536         # will be deadlock
1537         stat $MOUNT/widestripe || return 12
1538
1539         umount_client $MOUNT2 || return 13
1540         umount_client $MOUNT || return 14
1541         stop ost5 -f || return 20
1542         stop ost4 -f || return 21
1543         stop ost3 -f || return 22
1544         stop_ost2 || return 23
1545         stop_ost || return 24
1546         stop_mds || return 25
1547 }
1548 run_test 46a "handle ost additional - wide striped file"
1549
1550 test_47() { #17674
1551         reformat
1552         setup_noconfig
1553         check_mount || return 2
1554         $LCTL set_param ldlm.namespaces.$FSNAME-*-*-*.lru_size=100
1555
1556         local lru_size=[]
1557         local count=0
1558         for ns in $($LCTL get_param ldlm.namespaces.$FSNAME-*-*-*.lru_size); do
1559             lrs=$(echo $ns | sed 's/.*lru_size=//')
1560             lru_size[count]=$lrs
1561             let count=count+1
1562         done
1563
1564         facet_failover ost1
1565         facet_failover mds
1566         df -h $MOUNT || return 3
1567
1568         count=0
1569         for ns in $($LCTL get_param ldlm.namespaces.$FSNAME-*-*-*.lru_size); do
1570             lrs=$(echo $ns | sed 's/.*lru_size=//')
1571             if ! test "$lrs" -eq "${lru_size[count]}"; then
1572                 n=$(echo $ns | sed -e 's/ldlm.namespaces.//' -e 's/.lru_size=.*//')
1573                 error "$n has lost lru_size: $lrs vs. ${lru_size[count]}"
1574             fi
1575             let count=count+1
1576         done
1577
1578         cleanup
1579         return 0
1580 }
1581 run_test 47 "server restart does not make client loss lru_resize settings"
1582
1583 cleanup_48() {
1584         trap 0
1585
1586         # reformat after this test is needed - if test will failed
1587         # we will have unkillable file at FS
1588         reformat_and_config
1589 }
1590
1591 test_48() { # bug 17636
1592         reformat
1593         setup_noconfig
1594         check_mount || return 2
1595
1596         $LFS setstripe $MOUNT -c -1 || return 9
1597         $LFS getstripe $MOUNT || return 10
1598
1599         echo "ok" > $MOUNT/widestripe
1600         $LFS getstripe $MOUNT/widestripe || return 11
1601
1602         trap cleanup_48 EXIT ERR
1603
1604         # fill acl buffer for avoid expand lsm to them
1605         getent passwd | awk -F : '{ print "u:"$1":rwx" }' |  while read acl; do
1606             setfacl -m $acl $MOUNT/widestripe
1607         done
1608
1609         stat $MOUNT/widestripe || return 12
1610
1611         cleanup_48
1612         return 0
1613 }
1614 run_test 48 "too many acls on file"
1615
1616 # check PARAM_SYS_LDLM_TIMEOUT option of MKFS.LUSTRE
1617 test_49() { # bug 17710
1618         local OLD_MDS_MKFS_OPTS=$MDS_MKFS_OPTS
1619         local OLD_OST_MKFS_OPTS=$OST_MKFS_OPTS
1620         local LOCAL_TIMEOUT=20
1621
1622         OST_MKFS_OPTS="--ost --fsname=$FSNAME --device-size=$OSTSIZE --mgsnode=$MGSNID --param sys.timeout=$LOCAL_TIMEOUT --param sys.ldlm_timeout=$LOCAL_TIMEOUT $MKFSOPT $OSTOPT"
1623
1624         reformat
1625         start_mds
1626         start_ost
1627         mount_client $MOUNT
1628         check_mount || return 1
1629
1630         echo "check ldlm_timout..."
1631         LDLM_MDS="`do_facet mds lctl get_param -n ldlm_timeout`"
1632         LDLM_OST1="`do_facet ost1 lctl get_param -n ldlm_timeout`"
1633         LDLM_CLIENT="`do_facet client lctl get_param -n ldlm_timeout`"
1634
1635         if [ $LDLM_MDS -ne $LDLM_OST1 ] || [ $LDLM_MDS -ne $LDLM_CLIENT ]; then
1636                 error "Different LDLM_TIMEOUT:$LDLM_MDS $LDLM_OST1 $LDLM_CLIENT"
1637         fi
1638
1639         if [ $LDLM_MDS -ne $((LOCAL_TIMEOUT / 3)) ]; then
1640                 error "LDLM_TIMEOUT($LDLM_MDS) is not correct"
1641         fi
1642
1643         umount_client $MOUNT
1644         stop_ost || return 2
1645         stop_mds || return 3
1646
1647         OST_MKFS_OPTS="--ost --fsname=$FSNAME --device-size=$OSTSIZE --mgsnode=$MGSNID --param sys.timeout=$LOCAL_TIMEOUT --param sys.ldlm_timeout=$((LOCAL_TIMEOUT - 1)) $MKFSOPT $OSTOPT"
1648
1649         reformat
1650         start_mds || return 4
1651         start_ost || return 5
1652         mount_client $MOUNT || return 6
1653         check_mount || return 7
1654
1655         LDLM_MDS="`do_facet mds lctl get_param -n ldlm_timeout`"
1656         LDLM_OST1="`do_facet ost1 lctl get_param -n ldlm_timeout`"
1657         LDLM_CLIENT="`do_facet client lctl get_param -n ldlm_timeout`"
1658
1659         if [ $LDLM_MDS -ne $LDLM_OST1 ] || [ $LDLM_MDS -ne $LDLM_CLIENT ]; then
1660                 error "Different LDLM_TIMEOUT:$LDLM_MDS $LDLM_OST1 $LDLM_CLIENT"
1661         fi
1662
1663         if [ $LDLM_MDS -ne $((LOCAL_TIMEOUT - 1)) ]; then
1664                 error "LDLM_TIMEOUT($LDLM_MDS) is not correct"
1665         fi
1666
1667         cleanup || return $?
1668
1669         MDS_MKFS_OPTS=$OLD_MDS_MKFS_OPTS
1670         OST_MKFS_OPTS=$OLD_OST_MKFS_OPTS
1671 }
1672 run_test 49 "check PARAM_SYS_LDLM_TIMEOUT option of MKFS.LUSTRE"
1673
1674 lazystatfs() {
1675         # Test both statfs and lfs df and fail if either one fails
1676         multiop_bg_pause $1 f_
1677         RC1=$?
1678         PID=$!
1679         killall -USR1 multiop
1680         [ $RC1 -ne 0 ] && log "lazystatfs multiop failed"
1681         wait $PID || { RC1=$?; log "multiop return error "; }
1682
1683         $LFS df &
1684         PID=$!
1685         sleep 5
1686         kill -s 0 $PID
1687         RC2=$?
1688         if [ $RC2 -eq 0 ]; then
1689             kill -s 9 $PID
1690             log "lazystatfs df failed"
1691         fi
1692
1693         RC=0
1694         [[ $RC1 -ne 0 || $RC2 -eq 0 ]] && RC=1
1695         return $RC
1696 }
1697
1698 test_50a() {
1699         setup
1700         lctl set_param llite.$FSNAME-*.lazystatfs=1
1701         touch $DIR/$tfile
1702
1703         lazystatfs $MOUNT || error "lazystatfs failed but no down servers"
1704
1705         cleanup || return $?
1706 }
1707 run_test 50a "lazystatfs all servers available =========================="
1708
1709 test_50b() {
1710         setup
1711         lctl set_param llite.$FSNAME-*.lazystatfs=1
1712         touch $DIR/$tfile
1713
1714         # Wait for client to detect down OST
1715         stop_ost || error "Unable to stop OST1"
1716         wait_osc_import_state mds ost DISCONN
1717
1718         lazystatfs $MOUNT || error "lazystatfs should don't have returned EIO"
1719
1720         umount_client $MOUNT || error "Unable to unmount client"
1721         stop_mds || error "Unable to stop MDS"
1722 }
1723 run_test 50b "lazystatfs all servers down =========================="
1724
1725 test_50c() {
1726         start_mds || error "Unable to start MDS"
1727         start_ost || error "Unable to start OST1"
1728         start_ost2 || error "Unable to start OST2"
1729         mount_client $MOUNT || error "Unable to mount client"
1730         lctl set_param llite.$FSNAME-*.lazystatfs=1
1731         touch $DIR/$tfile
1732
1733         # Wait for client to detect down OST
1734         stop_ost || error "Unable to stop OST1"
1735         wait_osc_import_state mds ost DISCONN
1736         lazystatfs $MOUNT || error "lazystatfs failed with one down server"
1737
1738         umount_client $MOUNT || error "Unable to unmount client"
1739         stop_ost2 || error "Unable to stop OST2"
1740         stop_mds || error "Unable to stop MDS"
1741 }
1742 run_test 50c "lazystatfs one server down =========================="
1743
1744 test_50d() {
1745         start_mds || error "Unable to start MDS"
1746         start_ost || error "Unable to start OST1"
1747         start_ost2 || error "Unable to start OST2"
1748         mount_client $MOUNT || error "Unable to mount client"
1749         lctl set_param llite.$FSNAME-*.lazystatfs=1
1750         touch $DIR/$tfile
1751
1752         # Issue the statfs during the window where the client still
1753         # belives the OST to be available but it is in fact down.
1754         # No failure just a statfs which hangs for a timeout interval.
1755         stop_ost || error "Unable to stop OST1"
1756         lazystatfs $MOUNT || error "lazystatfs failed with one down server"
1757
1758         umount_client $MOUNT || error "Unable to unmount client"
1759         stop_ost2 || error "Unable to stop OST2"
1760         stop_mds || error "Unable to stop MDS"
1761 }
1762 run_test 50d "lazystatfs client/server conn race =========================="
1763
1764 test_50e() {
1765         local RC1
1766         local pid
1767
1768         reformat_and_config
1769         start_mds || return 1
1770         #first client should see only one ost
1771         start_ost || return 2
1772         wait_osc_import_state mds ost FULL
1773
1774         # Wait for client to detect down OST
1775         stop_ost || error "Unable to stop OST1"
1776         wait_osc_import_state mds ost DISCONN
1777
1778         mount_client $MOUNT || error "Unable to mount client"
1779         lctl set_param llite.$FSNAME-*.lazystatfs=0
1780
1781         multiop_bg_pause $MOUNT _f
1782         RC1=$?
1783         pid=$!
1784
1785         if [ $RC1 -ne 0 ]; then
1786                 log "lazystatfs multiop failed $RC1"
1787         else
1788             kill -USR1 $pid
1789             sleep $(( $TIMEOUT+1 ))
1790             kill -0 $pid
1791             [ $? -ne 0 ] && error "process isn't sleep"
1792             start_ost || error "Unable to start OST1"
1793             wait $pid || error "statfs failed"
1794         fi
1795
1796         umount_client $MOUNT || error "Unable to unmount client"
1797         stop_ost || error "Unable to stop OST1"
1798         stop_mds || error "Unable to stop MDS"
1799 }
1800 run_test 50e "normal statfs all servers down =========================="
1801
1802 test_50f() {
1803         local RC1
1804         local pid
1805         CONN_PROC="osc.$FSNAME-OST0001-osc.ost_server_uuid"
1806
1807         start_mds || error "Unable to start mds"
1808         #first client should see only one ost
1809         start_ost || error "Unable to start OST1"
1810         wait_osc_import_state mds ost FULL
1811
1812         start_ost2 || error "Unable to start OST2"
1813         wait_osc_import_state mds ost2 FULL
1814
1815         # Wait for client to detect down OST
1816         stop_ost2 || error "Unable to stop OST2"
1817         wait_osc_import_state mds ost2 DISCONN
1818
1819         mount_client $MOUNT || error "Unable to mount client"
1820         lctl set_param llite.$FSNAME-*.lazystatfs=0
1821
1822         multiop_bg_pause $MOUNT _f
1823         RC1=$?
1824         pid=$!
1825
1826         if [ $RC1 -ne 0 ]; then
1827                 log "lazystatfs multiop failed $RC1"
1828         else
1829             kill -USR1 $pid
1830             sleep $(( $TIMEOUT+1 ))
1831             kill -0 $pid
1832             [ $? -ne 0 ] && error "process isn't sleep"
1833             start_ost2 || error "Unable to start OST1"
1834             wait $pid || error "statfs failed"
1835         fi
1836
1837         umount_client $MOUNT || error "Unable to unmount client"
1838         stop_ost || error "Unable to stop OST1"
1839         stop_mds || error "Unable to stop MDS"
1840 }
1841 run_test 50f "normal statfs one server in down =========================="
1842
1843 equals_msg `basename $0`: test complete
1844 [ -f "$TESTSUITELOG" ] && cat $TESTSUITELOG && grep -q FAIL $TESTSUITELOG && exit 1 || true